#
# Conditional build:
%bcond_without	tests	# testing
%bcond_with	sse2	# SSE2 instructions

%ifarch pentium4 %{x8664} x32
%define	with_sse2	1
%endif

Summary:	Cryptopp Library - a free C++ class library of cryptographic schemes
Summary(pl.UTF-8):	Cryptopp - biblioteka klas C++ dostarczająca narzędzia do kryptografii
Name:		cryptopp
Version:	8.9.0
%define	tag_ver	%(echo %{version} | tr . _)
Release:	1
License:	Boost v1.0 (BSD-like)
Group:		Libraries
#Source0Download: https://github.com/weidai11/cryptopp/releases
Source0:	https://github.com/weidai11/cryptopp/archive/CRYPTOPP_%{tag_ver}/%{name}-%{tag_ver}.tar.gz
# Source0-md5:	56f8ce6f2e052bd4b0129a04f38f2a0b
Source1:	%{name}.pc
URL:		https://cryptopp.com/
BuildRequires:	libstdc++-devel
BuildRequires:	unzip
%{?with_sse2:Requires:	cpuinfo(sse2)}
Obsoletes:	cryptopp-progs < 5.6
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Cryptopp Library is a free C++ class library of cryptographic schemes.

%description -l pl.UTF-8
Cryptopp jest biblioteką klas C++ dostarczającą narzędzia do
kryptografii.

%package devel
Summary:	Files for development of applications which will use Cryptopp
Summary(pl.UTF-8):	Pliki do tworzenia aplikacji używających Cryptopp
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
Files for development of applications which will use Cryptopp.

%description devel -l pl.UTF-8
Pliki do tworzenia aplikacji używających Cryptopp.

%package static
Summary:	Static Cryptopp library
Summary(pl.UTF-8):	Statyczna biblioteka Cryptopp
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static Cryptopp library.

%description static -l pl.UTF-8
Statyczna biblioteka Cryptopp.

%prep
%setup -q -n %{name}-CRYPTOPP_%{tag_ver}

%build
CXXFLAGS="%{rpmcxxflags} %{!?with_sse2:-DCRYPTOPP_DISABLE_SSE2} %{?with_sse2:-msse2}" \
%{__make} shared static %{?with_tests:cryptest.exe} \
	CXX="%{__cxx}"

%if %{with tests}
%{__make} test
%endif

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT \
	PREFIX=%{_prefix} \
	LIBDIR=%{_libdir}

install -d $RPM_BUILD_ROOT%{_pkgconfigdir}
sed -e "
	s|@PREFIX@|%{_prefix}|g
	s|@LIBDIR@|%{_libdir}|g
	s|@VERSION@|%{version}|g
" %{SOURCE1} > $RPM_BUILD_ROOT%{_pkgconfigdir}/cryptopp.pc

# tests
%{__rm} $RPM_BUILD_ROOT%{_bindir}/cryptest.exe
%{__rm} -r $RPM_BUILD_ROOT%{_datadir}/cryptopp/Test{Data,Vectors}

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%triggerpostun -- cryptopp < 5.6.5
rm -f %{_libdir}/libcryptopp.so.5.6
/sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc License.txt Readme.txt
%attr(755,root,root) %{_libdir}/libcryptopp.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libcryptopp.so.8

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libcryptopp.so
%{_includedir}/cryptopp
%{_pkgconfigdir}/cryptopp.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libcryptopp.a
%changelog
* Sun Oct 22 2023 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/cryptopp.git;a=log;h=master

* Sun Oct 22 2023 Jakub Bogusz <qboosh@pld-linux.org> 55a6708
- updated to 8.9.0

* Thu Jul 06 2023 Jakub Bogusz <qboosh@pld-linux.org> db31d96
- updated to 8.8.0

* Fri Mar 17 2023 Jakub Bogusz <qboosh@pld-linux.org> 638f962
- updated to 8.7.0
- disable sse2 on x86 by default (there is runtime detection, but compilation requires -msse2 then, so detection is useless)

* Mon Jul 22 2019 Jakub Bogusz <qboosh@pld-linux.org> b1c64d0
- updated to 8.2.0

* Sun Dec 30 2018 Jakub Bogusz <qboosh@pld-linux.org> 9c05bf6
- updated to 8.0.0 (fixes CVE-2017-9434 CVE-2016-9939, new soname)
- removed outdated opt patch

* Sat Dec 23 2017 Jakub Bogusz <qboosh@pld-linux.org> 4574ef3
- updated to 5.6.5 (fixes CVE-2016-3995)
- removed obsolete libdir patch (cmake support dropped)
- added opt patch (disable -march=native)

* Tue Jun 06 2017 Jakub Bogusz <qboosh@pld-linux.org> 64f5fd7
- added libdir patch (adjusts cmake install dir wrt. LIB_SUFFIX)
- no need to disable asm on x32 now

* Tue Jun 06 2017 Jakub Bogusz <qboosh@pld-linux.org> e7868f1
- updated to 5.6.4 (note: soname changed to follow upstream)
- removed obsolete cxx patch
- dropped autotools support provided by autotools patch; use upstream cmake support instead

* Wed Jan 20 2016 Elan Ruusamäe <glen@delfi.ee> 1efe63f
- build process is racy, link errors, etc

* Wed Jan 20 2016 Elan Ruusamäe <glen@delfi.ee> dd9c76e
- install pkg-config file

* Wed Jan 20 2016 Elan Ruusamäe <glen@delfi.ee> d0c3dcd
- rm unpackaged test

* Wed Jan 20 2016 Elan Ruusamäe <glen@delfi.ee> 17888f8
- tests bcond

* Sat Apr 11 2015 Jan Rękorajski <baggins@pld-linux.org> 72a0958
- disable asm code on x32
- rel 3

* Sun Sep 30 2012 Jakub Bogusz <qboosh@pld-linux.org> 98033b6
- O: cryptopp-progs

* Sun Sep 30 2012 Jakub Bogusz <qboosh@pld-linux.org> 4c7740b
- cleanups

* Mon Sep 10 2012 Paweł Sikora <pawel.sikora@agmk.net> e602bb4
- enable sse/asm, release 2.

* Sun Sep 09 2012 Paweł Sikora <pawel.sikora@agmk.net> 6081e9d
- fix .pl summary, cleanup dropped -progs desc, package .la

* Sun Sep 09 2012 Paweł Sikora <pawel.sikora@agmk.net> 36035fa
- try another download url.

* Tue Sep 04 2012 Paweł Sikora <pawel.sikora@agmk.net> 43576a0
- update source0.

* Tue Sep 04 2012 Paweł Sikora <pawel.sikora@agmk.net> fa8cb00
- bump autotools package version.

